package Team5.SmartTowns;

import org.junit.jupiter.api.AfterEach;
//import org.junit.jupiter.api.BeforeAll;
//import org.junit.jupiter.api.BeforeEach;


import org.junit.After;
import org.junit.Before;


//import org.junit.Test; //- using this stops initialisation error, and runs properly, but breaks firefox driver
import org.junit.jupiter.api.Test; //works but initialisation error
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.extension.ExtendWith;
import org.junit.runner.RunWith;

import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.firefox.FirefoxDriver;
import org.openqa.selenium.firefox.FirefoxOptions;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.context.annotation.Profile;
import org.springframework.test.context.ActiveProfiles;
import org.springframework.test.context.junit.jupiter.SpringExtension;
import org.springframework.test.context.junit4.SpringRunner;

import io.github.bonigarcia.wdm.WebDriverManager;


import static org.junit.Assert.assertTrue;
import static org.junit.jupiter.api.Assertions.assertEquals;

//@RunWith(SpringRunner.class)
@ExtendWith(SpringExtension.class)
@SpringBootTest(webEnvironment = SpringBootTest.WebEnvironment.RANDOM_PORT)
//@ActiveProfiles("test")
public class FirefoxDriverPagesTests {
    @Value("${local.server.port}")
    private int port;

    WebDriver webDriver;

    @BeforeAll // setupFirefoxDriver
    static void setupClass() {
        WebDriverManager.firefoxdriver().setup();
    }

    @BeforeEach
    void setupTest() {
        FirefoxOptions options = new FirefoxOptions();
        options.addArguments("--headless");
        webDriver = new FirefoxDriver(options);
//        webDriver = new FirefoxDriver();
    }
    @AfterEach
    void teardown() {
        webDriver.quit();
    }


    @Test
    public void pageSetupTest() {
    }

    @Test
    public void testHomePageContents() {
        this.webDriver.get("http://localhost:" + Integer.toString(port) + "/mobile-home");
//        assertEquals(1,1);
        assertTrue(webDriver.findElement(By.cssSelector("main")).getText().contains("Welcome to VZTA Smart Towns!"));


    }


}
